Subject: Re: [PATCH] be2net: Implementation of request_firmware interface.

From: Ben Hutchings <[email-masked]>
Date: Fri, 07 Aug 2009 14:20:13 +0100

On Fri, 2009-08-07 at 02:20 -0700, Ram Pai wrote:
> On Sun, 2009-07-05 at 15:20 +0100, Ben Hutchings wrote:
> > On Sun, 2009-07-05 at 17:46 +0530, Sarveshwar Bandi wrote:
> > > I understand that most drivers  use request_firmware() to load  volatile
> > > firmware. I do see that there are other nic drivers that use this inferface to
> > > flash persistent firmware.
> > > 
> > >  We have other tools for offline flashing; but there is requirement
> > > to flash f/w through driver without having to use other proprietary  tools.
> > 
> > The firmware blob is proprietary and has to be distributed separately
> > from the kernel.  So does it really matter that you have to distribute a
> > special tool as well?
> > 
> > (Based on requirements specified by major OEMs, I have implemented
> > firmware update through the sfc driver (MDIO and MTD interfaces) but
> > under the control of a separate tool.)
> > 
> > > Since the firmware load happens only when there is a version mismatch with
> > > f/w in /lib/firmware, Users who want to avoid automatic flashing at boot time
> > > can choose not to copy the f/w file under /lib/firmware.
> > [...]
> > 
> > Is there a way of loading the firmware into the controller's RAM but not
> > writing it to flash?  That ought to be the default behaviour.
> > 
> 
> Given that the volatile and non-volatile firmware reside in the same
> file, it is not possible for the driver to selectively load the intended
> firmware.

Your design error is your problem.

> However, is this behavior a gating factor for this patch from being
> accepted?

I'm not a gatekeeper; ask David Miller.

Ben.
 
-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.
They asked us to note that Solarflare product names are trademarked.